//+------------------------------------------------------------------+
//|                                          PerceptronIndicator.mq4 |
//|                                                           NoName |
//|                            http://www.tradersforum.net.ru/forum/ |
//+------------------------------------------------------------------+
#property copyright "NoName"
#property link      "http://www.tradersforum.net.ru/forum/"

#property indicator_separate_window
//#property indicator_minimum -1000
//#property indicator_maximum 1000
#property indicator_buffers 3
#property indicator_color1 Lime
#property indicator_color2 Red
//---- input parameters
extern double       x1=69.0;
extern double       x2=218.0;
extern double       x3=5.0;
extern double       x4=155.0;
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(3);
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexBuffer(1,ExtMapBuffer2);
   //------------------------------
   IndicatorShortName("Perceptron(x1="+x1+", x2="+x2+", x3="+x3+", x4="+x4+")");
   SetIndexLabel(0,"PercepronUP");
   SetIndexLabel(1,"PercepronDN");
   SetIndexLabel(2,"PercepronLN");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
 double w1 = x1 - 100.0;
 double w2 = x2 - 100.0;
 double w3 = x3 - 100.0;
 double w4 = x4 - 100.0;
 int limit;
 int counted_bars = IndicatorCounted();
 
 if(counted_bars > 0) counted_bars --;  
 
 limit = iBars(NULL, 0) - counted_bars;
   
for(int i = 0; i < limit; i++) 
   {
    double a1 = iAC(NULL, 0, i);
    double a2 = iAC(NULL, 0, i+7); 
    double a3 = iAC(NULL, 0, i+14); 
    double a4 = iAC(NULL, 0, i+21);
    double res =  NormalizeDouble((w1 * a1 * 1000), 1) + NormalizeDouble((w2 * a2 * 1000), 1)
                + NormalizeDouble((w3 * a3 * 1000), 1) + NormalizeDouble((w4 * a4 * 1000), 1);
    
    if(res>0) 
      {
       ExtMapBuffer1[i]=res;
       ExtMapBuffer2[i]=0.0;
      }
      
    if(res<0)
      {
       ExtMapBuffer2[i]=res; 
       ExtMapBuffer1[i]=0.0;
      }
   } 
Comment("Buffer1: ","x0= ",ExtMapBuffer1[0],", x1= ",ExtMapBuffer1[1],", x2= ",ExtMapBuffer1[2],
                         ", x3= ",ExtMapBuffer1[3],", x4= ",ExtMapBuffer1[4]/*,", x5= ",ExtMapBuffer1[5],
                         ", x6= ",ExtMapBuffer1[6],", x7= ",ExtMapBuffer1[7],", x8= ",ExtMapBuffer1[8],
                         ", x9= ",ExtMapBuffer1[9]*/," \n",
                         
               "Buffer2: ","y0= ",ExtMapBuffer2[0],", y1= ",ExtMapBuffer2[1],", y2= ",ExtMapBuffer2[2],
                         ", y3= ",ExtMapBuffer2[3],", y4= ",ExtMapBuffer2[4]/*,", y5= ",ExtMapBuffer2[5],
                         ", y6= ",ExtMapBuffer2[6],", y7= ",ExtMapBuffer2[7],", y8= ",ExtMapBuffer2[8],
                         ", y9= ",ExtMapBuffer2[9]*/," \n","res = ", res);

   return(0);
  }
//+------------------------------------------------------------------+

